#include<iostream>
#include<vector>
#define endl '\n'
using namespace std;
int t[100005];
vector< pair<int,int> > v;
int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n,m,a,b;
    cin>>n>>m;

    for(int i=1;i<=m;i++)
    {
        cin>>a>>b;
        if(a>b) swap(a,b);
        if(t[a]==0) {t[a]=i;continue;}
        v.push_back({t[a],i});
        t[a]=0;
    }
cout<<v.size()<<endl;

    for(int i=0;i<v.size();i++)
    {
        cout<<v[i].first<<" "<<v[i].second<<endl;
    }
}
